<html>
<head>
<title>OgreCompositionPass.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreCompositionPass.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreCompositionPass_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __CompositionPass_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __CompositionPass_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreMaterial_8h.html">OgreMaterial.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderSystem_8h.html">OgreRenderSystem.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderQueue_8h.html">OgreRenderQueue.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00046"></a><a class="code" href="classOgre_1_1CompositionPass.html">00046</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1CompositionPass.html" title="Object representing one pass or operation in a composition sequence.">CompositionPass</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">CompositorInstAlloc</a>
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048     <span class="keyword">public</span>:
<a name="l00049"></a>00049         <a class="code" href="classOgre_1_1CompositionPass.html" title="Object representing one pass or operation in a composition sequence.">CompositionPass</a>(<a class="code" href="classOgre_1_1CompositionTargetPass.html" title="Object representing one render to a RenderTarget or Viewport in the Ogre Composition framework...">CompositionTargetPass</a> *parent);
<a name="l00050"></a>00050         ~<a class="code" href="classOgre_1_1CompositionPass.html" title="Object representing one pass or operation in a composition sequence.">CompositionPass</a>();
<a name="l00051"></a>00051         
<a name="l00054"></a><a class="code" href="classOgre_1_1CompositionPass.html#aa20bff864069127a799a3593df0146aa">00054</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1CompositionPass.html#aa20bff864069127a799a3593df0146aa" title="Enumeration that enumerates the various composition pass types.">PassType</a>
<a name="l00055"></a>00055         {
<a name="l00056"></a><a class="code" href="classOgre_1_1CompositionPass.html#aa20bff864069127a799a3593df0146aaaa7d4ed28ab9cdd43e85a715bd4e068fc">00056</a>             <a class="code" href="classOgre_1_1CompositionPass.html#aa20bff864069127a799a3593df0146aaaa7d4ed28ab9cdd43e85a715bd4e068fc">PT_CLEAR</a>,           <span class="comment">// Clear target to one colour</span>
<a name="l00057"></a><a class="code" href="classOgre_1_1CompositionPass.html#aa20bff864069127a799a3593df0146aaa43301dad285fba17915d7867665597ab">00057</a>             <a class="code" href="classOgre_1_1CompositionPass.html#aa20bff864069127a799a3593df0146aaa43301dad285fba17915d7867665597ab">PT_STENCIL</a>,         <span class="comment">// Set stencil operation</span>
<a name="l00058"></a><a class="code" href="classOgre_1_1CompositionPass.html#aa20bff864069127a799a3593df0146aaac8aa60611671e1b8867c1a30775ba84c">00058</a>             <a class="code" href="classOgre_1_1CompositionPass.html#aa20bff864069127a799a3593df0146aaac8aa60611671e1b8867c1a30775ba84c">PT_RENDERSCENE</a>,     <span class="comment">// Render the scene or part of it</span>
<a name="l00059"></a><a class="code" href="classOgre_1_1CompositionPass.html#aa20bff864069127a799a3593df0146aaa39b1d2658f5c73b04755e428316ea366">00059</a>             <a class="code" href="classOgre_1_1CompositionPass.html#aa20bff864069127a799a3593df0146aaa39b1d2658f5c73b04755e428316ea366">PT_RENDERQUAD</a>,      <span class="comment">// Render a full screen quad</span>
<a name="l00060"></a><a class="code" href="classOgre_1_1CompositionPass.html#aa20bff864069127a799a3593df0146aaaba93db3e2878858fe2fd199354c82af9">00060</a>             PT_RENDERCUSTOM     <span class="comment">// Render a custom sequence</span>
<a name="l00061"></a>00061         };
<a name="l00062"></a>00062         
<a name="l00064"></a>00064         <span class="keywordtype">void</span> setType(PassType type);
<a name="l00066"></a>00066         PassType getType() <span class="keyword">const</span>;
<a name="l00067"></a>00067         
<a name="l00071"></a>00071         <span class="keywordtype">void</span> setIdentifier(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <span class="keywordtype">id</span>);
<a name="l00073"></a>00073         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getIdentifier() <span class="keyword">const</span>;
<a name="l00074"></a>00074 
<a name="l00078"></a>00078         <span class="keywordtype">void</span> setMaterial(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat);
<a name="l00082"></a>00082         <span class="keywordtype">void</span> setMaterialName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name);
<a name="l00086"></a>00086         <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial() <span class="keyword">const</span>;
<a name="l00090"></a>00090         <span class="keywordtype">void</span> setFirstRenderQueue(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <span class="keywordtype">id</span>);
<a name="l00094"></a>00094         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> getFirstRenderQueue() <span class="keyword">const</span>;
<a name="l00098"></a>00098         <span class="keywordtype">void</span> setLastRenderQueue(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <span class="keywordtype">id</span>);
<a name="l00102"></a>00102         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> getLastRenderQueue() <span class="keyword">const</span>;
<a name="l00103"></a>00103 
<a name="l00109"></a>00109         <span class="keywordtype">void</span> setMaterialScheme(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; schemeName);
<a name="l00115"></a>00115         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMaterialScheme(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00116"></a>00116 
<a name="l00127"></a>00127         <span class="keywordtype">void</span> setClearBuffers(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> val);
<a name="l00131"></a>00131         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getClearBuffers() <span class="keyword">const</span>;
<a name="l00135"></a>00135         <span class="keywordtype">void</span> setClearColour(<a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> val);
<a name="l00139"></a>00139         <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;getClearColour() <span class="keyword">const</span>;
<a name="l00143"></a>00143         <span class="keywordtype">void</span> setClearDepth(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> depth);
<a name="l00147"></a>00147         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getClearDepth() <span class="keyword">const</span>;
<a name="l00151"></a>00151         <span class="keywordtype">void</span> setClearStencil(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> value);
<a name="l00155"></a>00155         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getClearStencil() <span class="keyword">const</span>;
<a name="l00156"></a>00156 
<a name="l00160"></a>00160         <span class="keywordtype">void</span> setStencilCheck(<span class="keywordtype">bool</span> value);
<a name="l00164"></a>00164         <span class="keywordtype">bool</span> getStencilCheck() <span class="keyword">const</span>;
<a name="l00168"></a>00168         <span class="keywordtype">void</span> setStencilFunc(<a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> value); 
<a name="l00172"></a>00172         <a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> getStencilFunc() <span class="keyword">const</span>; 
<a name="l00176"></a>00176         <span class="keywordtype">void</span> setStencilRefValue(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> value);
<a name="l00180"></a>00180         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getStencilRefValue() <span class="keyword">const</span>;
<a name="l00184"></a>00184         <span class="keywordtype">void</span> setStencilMask(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> value);
<a name="l00188"></a>00188         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getStencilMask() <span class="keyword">const</span>;
<a name="l00192"></a>00192         <span class="keywordtype">void</span> setStencilFailOp(<a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> value);
<a name="l00196"></a>00196         <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> getStencilFailOp() <span class="keyword">const</span>;
<a name="l00200"></a>00200         <span class="keywordtype">void</span> setStencilDepthFailOp(<a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> value);
<a name="l00204"></a>00204         <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> getStencilDepthFailOp() <span class="keyword">const</span>;
<a name="l00208"></a>00208         <span class="keywordtype">void</span> setStencilPassOp(<a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> value);
<a name="l00212"></a>00212         <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> getStencilPassOp() <span class="keyword">const</span>;
<a name="l00216"></a>00216         <span class="keywordtype">void</span> setStencilTwoSidedOperation(<span class="keywordtype">bool</span> value);
<a name="l00220"></a>00220         <span class="keywordtype">bool</span> getStencilTwoSidedOperation() <span class="keyword">const</span>;
<a name="l00221"></a>00221 
<a name="l00223"></a><a class="code" href="structOgre_1_1CompositionPass_1_1InputTex.html">00223</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1CompositionPass_1_1InputTex.html" title="Inputs (for material used for rendering the quad)">InputTex</a>
<a name="l00224"></a>00224         {
<a name="l00226"></a><a class="code" href="structOgre_1_1CompositionPass_1_1InputTex.html#a549645d3640226a6cbd2bdb3d4f29d59">00226</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1CompositionPass_1_1InputTex.html#a549645d3640226a6cbd2bdb3d4f29d59" title="Name (local) of the input texture (empty == no input)">name</a>;
<a name="l00228"></a><a class="code" href="structOgre_1_1CompositionPass_1_1InputTex.html#afb900befa1a297701c434ccc65d3d810">00228</a>             <span class="keywordtype">size_t</span> <a class="code" href="structOgre_1_1CompositionPass_1_1InputTex.html#afb900befa1a297701c434ccc65d3d810" title="MRT surface index if applicable.">mrtIndex</a>;
<a name="l00229"></a><a class="code" href="structOgre_1_1CompositionPass_1_1InputTex.html#a5f5c8dbdb4aabf1584453cefb997ae03">00229</a>             <a class="code" href="structOgre_1_1CompositionPass_1_1InputTex.html#a5f5c8dbdb4aabf1584453cefb997ae03">InputTex</a>() : name(<a class="code" href="classOgre_1_1StringUtil.html" title="Utility class for manipulating Strings.">StringUtil</a>::BLANK), mrtIndex(0) {}
<a name="l00230"></a><a class="code" href="structOgre_1_1CompositionPass_1_1InputTex.html#a0c02e4a4e46c29f23af2e5cfdd4e01aa">00230</a>             <a class="code" href="structOgre_1_1CompositionPass_1_1InputTex.html" title="Inputs (for material used for rendering the quad)">InputTex</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; _name, <span class="keywordtype">size_t</span> _mrtIndex = 0)
<a name="l00231"></a>00231                 : name(_name), mrtIndex(_mrtIndex) {}
<a name="l00232"></a>00232         };
<a name="l00233"></a>00233 
<a name="l00240"></a>00240         <span class="keywordtype">void</span> setInput(<span class="keywordtype">size_t</span> <span class="keywordtype">id</span>, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;input=<a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>, <span class="keywordtype">size_t</span> mrtIndex=0);
<a name="l00241"></a>00241         
<a name="l00246"></a>00246         <span class="keyword">const</span> InputTex &amp;getInput(<span class="keywordtype">size_t</span> <span class="keywordtype">id</span>) <span class="keyword">const</span>;
<a name="l00247"></a>00247         
<a name="l00251"></a>00251         <span class="keywordtype">size_t</span> getNumInputs() <span class="keyword">const</span>;
<a name="l00252"></a>00252         
<a name="l00256"></a>00256         <span class="keywordtype">void</span> clearAllInputs();
<a name="l00257"></a>00257         
<a name="l00261"></a>00261         <a class="code" href="classOgre_1_1CompositionTargetPass.html" title="Object representing one render to a RenderTarget or Viewport in the Ogre Composition framework...">CompositionTargetPass</a> *getParent();
<a name="l00262"></a>00262 
<a name="l00265"></a>00265         <span class="keywordtype">bool</span> _isSupported(<span class="keywordtype">void</span>);
<a name="l00266"></a>00266 
<a name="l00270"></a>00270         <span class="keywordtype">void</span> setQuadCorners(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left,<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top,<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> right,<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> bottom);
<a name="l00271"></a>00271 
<a name="l00275"></a>00275         <span class="keywordtype">bool</span> getQuadCorners(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> &amp; left,<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> &amp; top,<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> &amp; right,<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> &amp; bottom) <span class="keyword">const</span>;
<a name="l00276"></a>00276             
<a name="l00280"></a>00280         <span class="keywordtype">void</span> setQuadFarCorners(<span class="keywordtype">bool</span> farCorners, <span class="keywordtype">bool</span> farCornersViewSpace);
<a name="l00281"></a>00281 
<a name="l00285"></a>00285         <span class="keywordtype">bool</span> getQuadFarCorners() <span class="keyword">const</span>;
<a name="l00286"></a>00286 
<a name="l00290"></a>00290         <span class="keywordtype">bool</span> getQuadFarCornersViewSpace() <span class="keyword">const</span>;
<a name="l00291"></a>00291 
<a name="l00296"></a>00296         <span class="keywordtype">void</span> setCustomType(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; customType);
<a name="l00297"></a>00297 
<a name="l00302"></a>00302         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getCustomType() <span class="keyword">const</span>;
<a name="l00303"></a>00303 
<a name="l00304"></a>00304     <span class="keyword">private</span>:
<a name="l00306"></a><a class="code" href="classOgre_1_1CompositionPass.html#a69dbfadbe08123a3654988001408fe1f">00306</a>         <a class="code" href="classOgre_1_1CompositionTargetPass.html" title="Object representing one render to a RenderTarget or Viewport in the Ogre Composition framework...">CompositionTargetPass</a> *<a class="code" href="classOgre_1_1CompositionPass.html#a69dbfadbe08123a3654988001408fe1f" title="Parent technique.">mParent</a>;
<a name="l00308"></a><a class="code" href="classOgre_1_1CompositionPass.html#a7ebe674aa91f64ac46c0a69e6fad1152">00308</a>         <a class="code" href="classOgre_1_1CompositionPass.html#aa20bff864069127a799a3593df0146aa" title="Enumeration that enumerates the various composition pass types.">PassType</a> <a class="code" href="classOgre_1_1CompositionPass.html#a7ebe674aa91f64ac46c0a69e6fad1152" title="Type of composition pass.">mType</a>;
<a name="l00310"></a><a class="code" href="classOgre_1_1CompositionPass.html#aa84ac5b3a9a4d54da2d129a4567577c1">00310</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1CompositionPass.html#aa84ac5b3a9a4d54da2d129a4567577c1" title="Identifier for this pass.">mIdentifier</a>;
<a name="l00312"></a><a class="code" href="classOgre_1_1CompositionPass.html#ac8d59078bba510dca3b7796f63b2ba45">00312</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> <a class="code" href="classOgre_1_1CompositionPass.html#ac8d59078bba510dca3b7796f63b2ba45" title="Material used for rendering.">mMaterial</a>;
<a name="l00314"></a><a class="code" href="classOgre_1_1CompositionPass.html#ac149ba2f99beef55ca6144228a978244">00314</a>         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1CompositionPass.html#ac149ba2f99beef55ca6144228a978244" title="[first,last] render queue to render this pass (in case of PT_RENDERSCENE)">mFirstRenderQueue</a>;
<a name="l00315"></a><a class="code" href="classOgre_1_1CompositionPass.html#a9e6a2138976e30de8edd13abeb5350b7">00315</a>         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1CompositionPass.html#a9e6a2138976e30de8edd13abeb5350b7">mLastRenderQueue</a>;
<a name="l00317"></a><a class="code" href="classOgre_1_1CompositionPass.html#ad5a68caecdab4fab44031c21ebaa35fa">00317</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1CompositionPass.html#ad5a68caecdab4fab44031c21ebaa35fa" title="Material scheme name.">mMaterialScheme</a>;
<a name="l00319"></a><a class="code" href="classOgre_1_1CompositionPass.html#a3b282ac94558d8642b090a6d0f36749b">00319</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1CompositionPass.html#a3b282ac94558d8642b090a6d0f36749b" title="Clear buffers (in case of PT_CLEAR)">mClearBuffers</a>;
<a name="l00321"></a><a class="code" href="classOgre_1_1CompositionPass.html#abf96127effdcc34e974d67c93e8cc087">00321</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> <a class="code" href="classOgre_1_1CompositionPass.html#abf96127effdcc34e974d67c93e8cc087" title="Clear colour (in case of PT_CLEAR)">mClearColour</a>;
<a name="l00323"></a><a class="code" href="classOgre_1_1CompositionPass.html#af0424e3195c69bb730051295932146bf">00323</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1CompositionPass.html#af0424e3195c69bb730051295932146bf" title="Clear depth (in case of PT_CLEAR)">mClearDepth</a>;
<a name="l00325"></a><a class="code" href="classOgre_1_1CompositionPass.html#a307f1133d7e5941e1542f8a21a3079b9">00325</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1CompositionPass.html#a307f1133d7e5941e1542f8a21a3079b9" title="Clear stencil value (in case of PT_CLEAR)">mClearStencil</a>;
<a name="l00328"></a><a class="code" href="classOgre_1_1CompositionPass.html#a0739318ba2d47d4b29e7a0a14d0cbd63">00328</a>         <a class="code" href="structOgre_1_1CompositionPass_1_1InputTex.html" title="Inputs (for material used for rendering the quad)">InputTex</a> mInputs[<a class="code" href="OgreConfig_8h.html#a1c5fd80e6e0f2f85d6facbe1ec8eb5a4" title="Define max number of texture layers allowed per pass on any card.">OGRE_MAX_TEXTURE_LAYERS</a>];
<a name="l00330"></a><a class="code" href="classOgre_1_1CompositionPass.html#a8b348a1876efc360bf602fd7f7ea0029">00330</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositionPass.html#a8b348a1876efc360bf602fd7f7ea0029" title="Stencil operation parameters.">mStencilCheck</a>;
<a name="l00331"></a><a class="code" href="classOgre_1_1CompositionPass.html#ad49e026bd0e97265aedc4f701269ceca">00331</a>         <a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> <a class="code" href="classOgre_1_1CompositionPass.html#ad49e026bd0e97265aedc4f701269ceca">mStencilFunc</a>; 
<a name="l00332"></a><a class="code" href="classOgre_1_1CompositionPass.html#a06bfb33608f605cc216ce88342f5f2ca">00332</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1CompositionPass.html#a06bfb33608f605cc216ce88342f5f2ca">mStencilRefValue</a>;
<a name="l00333"></a><a class="code" href="classOgre_1_1CompositionPass.html#a50d4b6015739493ab4ebeb51232761a4">00333</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1CompositionPass.html#a50d4b6015739493ab4ebeb51232761a4">mStencilMask</a>;
<a name="l00334"></a><a class="code" href="classOgre_1_1CompositionPass.html#a7da3a87b2029d343068fd903efef2549">00334</a>         <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> <a class="code" href="classOgre_1_1CompositionPass.html#a7da3a87b2029d343068fd903efef2549">mStencilFailOp</a>;
<a name="l00335"></a><a class="code" href="classOgre_1_1CompositionPass.html#a325047bcd0a7f8ce097ddb4aee685e81">00335</a>         <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> <a class="code" href="classOgre_1_1CompositionPass.html#a325047bcd0a7f8ce097ddb4aee685e81">mStencilDepthFailOp</a>;
<a name="l00336"></a><a class="code" href="classOgre_1_1CompositionPass.html#aeb86ae7589d68c40a953c13d52b43115">00336</a>         <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> <a class="code" href="classOgre_1_1CompositionPass.html#aeb86ae7589d68c40a953c13d52b43115">mStencilPassOp</a>;
<a name="l00337"></a><a class="code" href="classOgre_1_1CompositionPass.html#a13aadcaf16c50cd38ca95dc7a161fe4d">00337</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositionPass.html#a13aadcaf16c50cd38ca95dc7a161fe4d">mStencilTwoSidedOperation</a>;
<a name="l00338"></a>00338 
<a name="l00340"></a><a class="code" href="classOgre_1_1CompositionPass.html#a61bd8f8f5775ea98dc620c9af1ed5b4f">00340</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1CompositionPass.html#a61bd8f8f5775ea98dc620c9af1ed5b4f" title="true if quad should not cover whole screen">mQuadCornerModified</a>;
<a name="l00342"></a><a class="code" href="classOgre_1_1CompositionPass.html#a78ae919b705cfc954f6f4eeb26c78764">00342</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1CompositionPass.html#a78ae919b705cfc954f6f4eeb26c78764" title="quad positions in normalised coordinates [-1;1]x[-1;1] (in case of PT_RENDERQUAD)">mQuadLeft</a>;
<a name="l00343"></a><a class="code" href="classOgre_1_1CompositionPass.html#aca899e03b6e14cbc8292ca18e74ac77f">00343</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1CompositionPass.html#aca899e03b6e14cbc8292ca18e74ac77f">mQuadTop</a>;
<a name="l00344"></a><a class="code" href="classOgre_1_1CompositionPass.html#ab43fed9e7b36e888bc89213fe066455e">00344</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1CompositionPass.html#ab43fed9e7b36e888bc89213fe066455e">mQuadRight</a>;
<a name="l00345"></a><a class="code" href="classOgre_1_1CompositionPass.html#a7322bb95b2b6c75a96233dc9cec338a1">00345</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1CompositionPass.html#a7322bb95b2b6c75a96233dc9cec338a1">mQuadBottom</a>;
<a name="l00346"></a>00346 
<a name="l00347"></a><a class="code" href="classOgre_1_1CompositionPass.html#a28971217281037ce619416c6181af889">00347</a>         <span class="keywordtype">bool</span> mQuadFarCorners, <a class="code" href="classOgre_1_1CompositionPass.html#a28971217281037ce619416c6181af889">mQuadFarCornersViewSpace</a>;
<a name="l00348"></a>00348         <span class="comment">//The type name of the custom composition pass.</span>
<a name="l00349"></a><a class="code" href="classOgre_1_1CompositionPass.html#a2654962285520bf83d0e93bdf9bf615c">00349</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1CompositionPass.html#a2654962285520bf83d0e93bdf9bf615c">mCustomType</a>;
<a name="l00350"></a>00350     };
<a name="l00354"></a>00354 }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
